answer/urls.py
__author__ = 'SOROOSH'

from django.conf.urls import patterns, url
from answer import views

urlpatterns = patterns('',
                       url(r'^analyze/(?i)(?P<exam_id>\d*)', views.analyze_answer, name='analyze'),
)

azma/urls.py
from django.conf.urls import patterns, include, url
from django.contrib import admin
from django.contrib.staticfiles.urls import staticfiles_urlpatterns

from azma import views


admin.autodiscover()

urlpatterns = patterns('',
                       # Examples:
                       # url(r'^$', 'azma.views.home', name='home'),
                       # url(r'^blog/', include('blog.urls')),
                       url(r'^tinymce/', include('tinymce.urls')),
                       url(r'^cms/', include('azma_cms.urls')),
                       url(r'^blog/', include('elephantblog.urls')),
                       url(r'^comments/', include('django.contrib.comments.urls')),
                       url(r'^(?i)admin/', include(admin.site.urls)),
                       url(r'^(?i)about', views.about, name='about'),
                       url(r'^(?i)user/', include('user.urls')),
                       url(r'^(?i)profile', include('user_profile.urls', namespace='profile')),
                       url(r'^(?i)wage_meter/', include('wage_meter.urls', namespace='wages')),
                       url(r'^(?i)answer/', include('answer.urls', namespace='answer')),
                       url(r'^(?i)tutorial/', include('tutorial.urls', namespace='tutorial')),
                       url(r'^', include('exam.urls', namespace='exam')),
)

urlpatterns += staticfiles_urlpatterns()

exam/urls.py
from django.conf.urls import patterns, url
from exam import views

urlpatterns = patterns('',
                       url(r'^(?i)$', views.index, name='index'),
                       url(r'^(?i)what$', views.what, name='what'),
                       url(r'^exam/(?i)(?P<exam_id>\d*)', views.intro, name='intro'),
                       url(r'^start/(?i)(?P<exam_id>\d*)', views.start, name='start'),
                       url(r'^(?i)cat/(?P<category_id>\d*)', views.sub_categories, name='sub_categories')
)

exam/models.py
import os
import datetime

from django.db import models
from django.db.models import Sum, Count
from django.utils.encoding import force_text, force_str
from elephantblog.models import Entry
from feincms.content.comments.models import CommentsContent
from feincms.content.medialibrary.models import MediaFileContent
from feincms.content.richtext.models import RichTextContent
from django_enumfield import enum


class ExamCategory(models.Model):
    
    name = models.CharField(max_length=200)
    local_name = models.CharField(max_length=200)
    parent = models.ForeignKey("self", null=True, blank=True, related_name='sub_categories')


    def number_of_exams(self):
        return self.exam_set.count()

    def __str__(self):
        return self.name


class ExamState(enum.Enum):
    PENDING = 0
    PUBLISHED = 1
    FINISHED = 2
    labels = {
        PENDING: 'Pending',
        PUBLISHED: 'Published',
        FINISHED: 'Finished',
    }


class Exam(models.Model):
    name = models.CharField(max_length=200)
    local_name = models.CharField(max_length=200)
    start_date = models.DateTimeField()
    end_date = models.DateTimeField(null=True, blank=True)
    description = models.CharField(max_length=2000)
    duration = models.IntegerField()
    category = models.ForeignKey(ExamCategory)
    number_of_attempts = models.IntegerField(default=1)
    exam_state = enum.EnumField(ExamState, default=ExamState.PENDING)


    def score(self):
        score = self.question_set.aggregate(Sum('score'))['score__sum']
        if score is None:
            return 0
        else:
            return score


    def __str__(self):
        return str(self.pk) + " " + self.name


class RequiredKnowledge(models.Model):
    name = models.CharField(max_length=200)
    exams = models.ManyToManyField(Exam, related_name='required_knowledge')

    def __str__(self):
        return self.name


def update_image_name(instance, filename):
    return os.path.join(
        os.path.join(os.path.normpath(force_text(datetime.datetime.now().strftime(force_str('question/images')))),
                     str(instance.id)) + '.png')


class Question(models.Model):
    text = models.CharField(max_length=500)
    exam = models.ForeignKey(Exam)
    score = models.IntegerField(default=1)
    code = models.TextField(null=True, blank=True)
    image = models.FileField(upload_to=update_image_name, null=True, blank=True)
    # according to this doc : https://docs.djangoproject.com/en/1.7/ref/models/fields/
    JAVA = "java"
    JS = "javascript"
    PHP = "PHP"
    LANGUAGES = (
        (JAVA, "Java"),
        (JS, "Javascript"),
        (PHP, "PHP")
    )
    code_type = models.CharField(max_length=15, choices=LANGUAGES, default=JAVA)


    def number_of_answers(self):
        return self.choice_set.filter(answer=True).aggregate(Count('answer'))['answer__count']


    def __str__(self):
        return str(self.id)


class Choice(models.Model):
    text = models.CharField(max_length=200)
    question = models.ForeignKey(Question)
    answer = models.BooleanField(default=False)

    def __str__(self):
        return str(self.pk)


# Entry.register_extensions('feincms.module.extensions.datepublisher',
# 'feincms.module.extensions.translations',
#                           'elephantblog.extensions.blogping',
# )
#
# Page.register_extensions(
#     'feincms.module.page.extensions.sites',
#     'feincms.module.page.extensions.titles',
# )
#
# Entry.register_extensions('feincms.module.extensions.datepublisher',
#                           # 'feincms.module.extensions.translations',
#                           'elephantblog.extensions.blogping',
#
#                           'feincms.module.extensions.seo',
# )
#
Entry.register_regions(
    ('main', 'Main content area'),
    ('header', 'Header content area')
)
Entry.create_content_type(RichTextContent,
                          regions=('main', 'sidebar',))
#
Entry.create_content_type(MediaFileContent, TYPE_CHOICES=(
    ('default', 'default'),
))

Entry.create_content_type(CommentsContent)

exam/views.py
from django.core.exceptions import ObjectDoesNotExist
from django.core.urlresolvers import reverse
from django.db.models import Count
from django.db.models.aggregates import Avg
from django.template import RequestContext, loader
from django.http import HttpResponse, HttpResponseRedirect
from answer.models import ExamAnswerHistory
from django.core.urlresolvers import reverse
from django.views import generic
from exam.models import Exam, ExamCategory
from tutorial.models import Tutorial;

def what(request):
    template = loader.get_template('intro.html')
    context = RequestContext(request)
    return HttpResponse(template.render(context))


from django.utils import timezone


def intro(request, exam_id):
    if request.method == "GET":
        try:
            exam = Exam.objects.get(id=exam_id)
            template = loader.get_template('exam_intro.html')
            attempts = \
                ExamAnswerHistory.objects.filter(user_id=request.user.id, exam_id=exam_id).aggregate(Count('id'))[
                    'id__count']
            context = RequestContext(request, {'exam': exam, 'attempts': attempts, 'current_date': timezone.now()})
            return HttpResponse(template.render(context))
        except ObjectDoesNotExist as e:
            return HttpResponseRedirect(reverse('exam:home'))


def sub_categories(request, category_id):
    sub_categories = ExamCategory.objects.filter(parent__id=category_id)
    category = ExamCategory.objects.get(id=category_id)
    category_head = ExamCategory.objects.filter(parent__id=category_id)
    template = loader.get_template('sub_categories.html')
    context = RequestContext(request, {'sub_categories': sub_categories, 'category': category, 'category_head': category_head})
    return HttpResponse(template.render(context))


def start(request, exam_id):
    if request.method == "GET":
        exam = Exam.objects.get(id=exam_id)
        user_answers_count = \
            ExamAnswerHistory.objects.filter(exam_id=exam_id, user_id=request.user.id).aggregate(Count('id'))[
                'id__count']
        template = loader.get_template('start.html')
        participates_count = exam.examanswer_set.aggregate(Count('id'))['id__count']
        context = RequestContext(request, {'user_answers_count': user_answers_count, 'exam': exam,
                                           'participates_count': participates_count})
        return HttpResponse(template.render(context))
    else:
        return HttpResponse('% method is not permitted', request.method)


def index(request):

    latest_tutorials = Tutorial.objects.all().order_by('-registered_date').all()[:5]

    template = loader.get_template('home.html')
    context = RequestContext(request, {'latest_tu': latest_tutorials, })
    return HttpResponse(template.render(context))

exam/templates/exam_intro.html
{% extends 'base.html' %}
{% load i18n %}
{% load staticfiles %}

{% block js %}
    <script type="text/javascript" src="{% static "js/jquery.plugin.js" %}"></script>
    <script type="text/javascript" src="{% static "js/jquery.countdown.js" %}"></script>
    <script type="text/javascript" src="{% static "js/jquery.countdown-fa.js" %}"></script>
    <script type="text/javascript">
        $(document).ready(function () {
            {% if exam.number_of_attempts <= attempts %}
                alertBar('متاسفانه شما دیگر قادر به شرکت در این آزمون نیستید');
            {% endif %}
            {%  if exam.start_date > current_date %}
                $.countdown.setDefaults({description: 'تا شروع آزمون'});
                $('#timer').fadeIn('slow');
                $('#timer').countdown({onTick: function (periods) {
                    var secs = $.countdown.periodsToSeconds(periods);
                    if (secs == 0)
                        $('#timer').fadeOut('slow', function () {
                            $('#enter').fadeIn('slow');
                        });

                }, until: new Date({{ exam.start_date.year}}, {{ exam.start_date.month}}-1, {{ exam.start_date.day}})});
                {#            {% else %}#}

            {% endif %}
            $('#enter').fadeIn('slow');


        });
    </script>
{% endblock %}

{% block css %}
    <link href="{% static "css/jquery.countdown.css" %}" rel="stylesheet">

{% endblock %}

{% block content %}

    <div class="modal-open">
    <h1>آزمون {{ exam.local_name }} </h1>
    <hr >
    <div style="padding-top: 10px">
    <div class="">
    </div>
    <div style="background-color: #e0e0ff; height:auto; border-radius: 5px;border: solid 1px #9090ff;">
    <div style="padding: 20px">
        <p><b>
            {{ exam.description | safe }}
            </b>
        </p>
    <hr>
    <div class="duration"><b>مدت زمان آزمون:</b>
        {{ exam.duration }}
        دقیقه
    </div>
    <div class="">
        <b>تعداد دفعات شرکت شما در این آزمون:</b>
        {{ attempts }}
        از
        {{ exam.number_of_attempts }}
    </div>
    <br/>
    <hr>
    <div class="">
        <b>دانش مورد نیاز این آزمون </b>
        <ul>
            {% if exam.required_knowledge.exists %}
                {% for k in exam.required_knowledge.all %}
                    <li>{{ k.name }}</li>
                {% endfor %}
            {% else %}
                <li>دانش خاصی برای این آزمون مشخص نگردیده است
                </li>
            {% endif %}
        </ul>
    </div>


    <div id="timer" class="form-group timer" style="display: none;"></div>
    <div id="enter" class="enter" style="display: none; text-align: center;">
        {% if exam.number_of_attempts > attempts %}
            <a class="btn btn-primary btn-lg" style="width: 90%;margin-top: 20px;" href="{% url 'exam:start' exam.id %}">
                ورود به آزمون
            </a>
        {% endif %}

    </div>
    </div>
    </div>
    </div>
    </div>

{% endblock %}

exam/templates/intro.html
{% extends 'base.html' %}
{% block title %}بیشتر بدانید{% endblock %}
{#{% block css %} {% endblock %}#}


{% block content %}
    <!--
<div class="small-container animation3">
    <div class="container" style="padding-top: 50px;">

        <div class="row" style="padding-bottom: 70px;">
            <div class="col-lg-1">
            </div>
            <div class="col-md-5">
                <p class="bubble speech">آزما وب چیه؟</p>

                <p>
                    آزما یک سرویس کارا و مفید برای آزمودن دانش شما در زمینه های مختلف است.
                    با استفاده از این سرویس شما می توانید میزان تسلط خود بر روی مباحث موجود را بسنجید.
                    در کنار این خودآزمایی ما سرویس های دیگری به شما معرفی می کنیم تا خودآزمایی و یادگیری برای شما لذت
                    بخش تر شود.
                </p>

                <p class="bubble speech">
                    خب از کجا شروع کنم؟
                </p>

                <p>
                    چون ما نیاز داریم که بتونیم وضعیت شما دوست عزیز رو پیگیری کنیم و سرویس با کیفیتی رو به شما ارایه
                    بدیم - از شما استدعا داریم که در این وب سایت عضو بشید.
                    ما قول میدیم که
                    <a href="{% url 'register' %}">عضویت</a>
                    ۲ دقیقه بیشتر وقت شما رو نگیره.
                    یه قول دیگه هم میدیدم و اون اینه که "ارزششو داره".
                </p>

                <p class="bubble speech">
                    من میتونم تو آزمون ها شرکت کنم؟
                </p>

                <p>
                    چرا که نه؟ شما در تمام آزمون های آزما وب می توانید شرکت کنید و هیچ محدودیتی وجود ندارد.
                </p>
            </div>
            {% comment %}            <div class="col-lg-2">
            </div>{% endcomment %}
            <div class="col-md-5">
                <p class="bubble thought">کاش منم میتونستم کمک کنم</p>
                چرا که نه؟ اگر شما در هر بخش از پروژه علاقه به همکاری داشته باشید وب آزما با تمام وجود از شما استقبال می
                کند.
                شما می توانید در بخش های مختلفی همچون توسعه سرویس
                -
                تکمیل آزمون ها و ایجاد آزمون جدید
                -
                گزارش مشکلات موجود
                با ما همکاری کنید. اگر حس می کنید در زمینه ای قادر به همکاری هستید ولی در اینجا ذکر نشده حتما با ما تماس
                بگیرید.
            </div>
            <div class="col-lg-1">
            </div>
        </div>
    </div>
    </div>
    -->

    <div class="container">
        <div class="row">
            <div class="page-header">
                <h2>
                    بیشتر بدانید
                </h2>
            </div>
        </div>


        <div style="margin-top: 30px; ">
            <div class="panel-group" id="accordion">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">
                            <a data-toggle="collapse" data-parent="#accordion" href="#collapseOne">
                                آزما وب چیه؟
                            </a>
                        </h3>
                    </div>
                    <div id="collapseOne" class="panel-collapse collapse in">
                        <div class="panel-body">
                            آزما یک سرویس کارا و مفید برای آزمودن دانش شما در زمینه های مختلف است.<br>
                            با استفاده از این سرویس شما می توانید میزان تسلط خود بر روی مباحث موجود را بسنجید.<br>
                            در کنار این خودآزمایی ما سرویس های دیگری به شما معرفی می کنیم تا خودآزمایی و یادگیری برای شما لذت
                            بخش تر شود.<br>
                        </div>
                    </div>
                </div>
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">
                            <a data-toggle="collapse" data-parent="#accordion" href="#collapseTwo">
                                خب از کجا شروع کنم؟
                            </a>
                        </h3>
                    </div>
                    <div id="collapseTwo" class="panel-collapse collapse">
                        <div class="panel-body">
                            چون ما نیاز داریم که بتونیم وضعیت شما دوست عزیز رو پیگیری کنیم و سرویس با کیفیتی رو به شما ارایه بدیم , از شما استدعا داریم که در این وب سایت عضو بشید.<br>
                            ما قول میدیم که <a href="{% url 'register' %}">عضویت </a>۲ دقیقه بیشتر وقت شما رو نگیره. یه قول دیگه هم میدیدم و اون اینه که "ارزششو داره".
                        </div>
                    </div>
                </div>
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">
                            <a data-toggle="collapse" data-parent="#accordion" href="#collapseThree">
                                من میتونم تو آزمون ها شرکت کنم؟
                            </a>
                        </h3>
                    </div>
                    <div id="collapseThree" class="panel-collapse collapse">
                        <div class="panel-body">
                            چرا که نه؟ شما در تمام آزمون های آزما وب می توانید شرکت کنید و هیچ محدودیتی وجود ندارد.
                        </div>
                    </div>
                </div>
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">
                            <a data-toggle="collapse" data-parent="#accordion" href="#collapseFour">
                                کاش منم میتونستم کمک کنم
                            </a>
                        </h3>
                    </div>
                    <div id="collapseFour" class="panel-collapse collapse">
                        <div class="panel-body">
                            چرا که نه؟ اگر شما در هر بخش از پروژه علاقه به همکاری داشته باشید وب آزما با تمام وجود از شما استقبال می کند. <br>
                            شما می توانید در بخش های مختلفی همچون توسعه سرویس - تکمیل آزمون ها و ایجاد آزمون جدید - گزارش مشکلات موجود با ما همکاری کنید.<br>
                            اگر حس می کنید در زمینه ای قادر به همکاری هستید ولی در اینجا ذکر نشده حتما با ما تماس بگیرید.<br>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

exam/templates/start.html
{% extends 'base.html' %}
{% block title %}{{ exam.local_name }}{% endblock %}
{% load staticfiles %}
{% block css %}
    <link href="{% static "UI/checkbox/input.checkbox.css" %}" rel="stylesheet">
    <link href="{% static "UI/radiobutton/input.radiobutton.css" %}" rel="stylesheet">
    <link href="{% static "UI/img/img.css" %}" rel="stylesheet">
    <link href="{% static 'UI/codeHolder/codeHolder.css' %}" rel="stylesheet">
    <style>
        input {
            visibility: hidden;

        }
    </style>
    <noscript>
        <style>
            input {
                visibility: visible;
            }
        </style>
    </noscript>
{% endblock %}
{% block content %}
    <div class="modal fade">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header" >
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                    <h4 class="modal-title" >لطفا توجه کنید</h4>
                </div>

                <div class="modal-body">

                    {% if user.is_authenticated %}
                        <p>تعداد دفعات ممکن برای شرکت در این آزمون
                            <span style="color: red;">{{ exam.number_of_attempts }}</span>
                            می باشد.
                        </p>
                        <p>
                            تعداد دفعات شرکت شما تا کنون
                            {{ user_answers_count }}
                            می باشد.
                        </p>
                    {% else %}
                        <p>برای شرکت در آزمون شما می بایست عضو آزما وب باشید.</p>
                        <p>این کار تنها ۲ دقیقه از وقت شما را می گیرید.</p>
                        <a href="{% url 'register' %}">
                            ثبت نام
                        </a>
                    {% endif %}
                </div>

                <div class="modal-footer">
                    {% if user.is_authenticated %}
                        آزما وب آزمون خوبی را برای شما آرزو می کند.

                    {% else %}
                        به امید دیدار شما پس از عضویت
                    {% endif %}
                </div>
            </div>
        </div>
    </div>
<div style="margin-top: 20px; padding-top: 20px">
    <div class="row hidden-lg">
        <div class="exam-panel-row">
            <span class="glyphicon glyphicon-time"></span>
        </div>
        <div class="exam-panel-row">
            <span class="glyphicon glyphicon-question-sign"></span>
        </div>
        <div class="exam-panel-row">
            <div class="row">
                <div class="col-xs-2">
                    <span class="glyphicon glyphicon-stats"></span>
                </div>
                <div class="col-xs-9" style="padding-right: 5px;margin-top:4px;">
                    تعداد شرکت کنندگان: {{ participates_count }}
                    نفر

                </div>
            </div>
        </div>
    </div>
    </div>
    <div class="well-exam exam-panel hidden-sm hidden-xs hidden-md hidden-print">
        <div class="exam-panel-row">
            <span class="glyphicon glyphicon-time"></span>

        </div>
        <div class="exam-panel-row">
            <span class="glyphicon glyphicon-question-sign"></span>
        </div>
        <div class="exam-panel-row">
            <div class="row">
                <div class="col-md-2">
                    <span class="glyphicon glyphicon-stats"></span>
                </div>
                <div class="col-md-9" style="padding-right: 5px;margin-top:4px;">
                    تعداد شرکت کنندگان: {{ participates_count }}
                    نفر

                </div>
            </div>

        </div>
        <div class="exam-panel-row">

            <span class="glyphicon glyphicon-flash"></span>
        </div>


    </div>
    <form method="post"
            {% if user.is_authenticated and exam.number_of_attempts > user_answers_count %}
          action="{% url 'answer:analyze' exam.id %}"
            {% endif %}
            >

        {% if user.is_authenticated and exam.number_of_attempts > user_answers_count %}
            {% csrf_token %}
        {% endif %}
        <div class="row">
            <div class="col-xs-12 col-md-12 col-lg-9  table-bordered"
                 style="padding-bottom: 20px;padding-top: 20px;float:left;">
                {% for q in exam.question_set.all %}
                    <div class="well-exam" style="margin-bottom: 25px;box-shadow:3px 3px #F3F3F3;">
                        <div class="row">
                            <div class="col-lg-8" style="margin-bottom: 10px;">
                                <li>  {{ q.text | safe }} </li>
                            </div>
                            <div class="col-lg-4" style="margin-bottom: 10px;">
                                {% if q.image %}
                                    <img class="img-thumbnail exam-img" src="{{ q.image.url }}"/>
                                {% endif %}
                            </div>
                        </div>
                        {% if q.code %}
                            <div class="row">
                                <div class="col-lg-12">
                                    <div class="CodeSheet src-{{ q.code_type }}">
                                        <pre>{{ q.code }}</pre>
                                    </div>
                                </div>
                            </div>
                        {% endif %}
                        <div class="row">
                            {% for ch in q.choice_set.all %}
                                {% if ch.id != -1 %}
                                    <div class="col-lg-12 answer-option" style="padding-bottom: 10px;">
                                        <div class='checkbox'>
                                            <label for="opt{{ ch.id }}">
                                                <input id="opt{{ ch.id }}"
                                                       value="{{ ch.id }}"
                                                       name="{{ q.id }}"
                                                       type={% if q.number_of_answers > 1 %}'checkbox' {% else %}
                                                           'radio'{% endif %}/>

                                                {{ ch.text | safe }}

                                            </label>

                                        </div>
                                    </div>

                                {% endif %}
                            {% endfor %}
                        </div>
                    </div>
                {% endfor %}
                {% if user.is_authenticated and exam.number_of_attempts > user_answers_count %}
                    <button type="submit" class="btn btn-success btn-lg center-block">
                    ثبت
                    </button>
                {% endif %}
            </div>
        </div>
    </form>
{% endblock %}


{% block js %}
    <script src="{% static 'UI/checkbox/input.checkbox.js' %}" type="text/javascript"></script>
    <script src="{% static 'UI/radiobutton/input.radiobutton.js' %}" type="text/javascript"></script>
    <script src="{% static 'UI/img/img.js' %}" type="text/javascript"></script>
    <script src="{% static 'UI/codeHolder/codeHolder.js' %}" type="text/javascript"></script>



    <script type="text/javascript">
        $(window).ready(function () {
            $('.modal').modal();
        });
    </script>

{% endblock %}

exam/templates/sub_categories.html
{% extends 'base.html' %}
{% load staticfiles %}
{% block title %}{{ category.local_name }}{% endblock %}
{% block content %}
    <div class="page-header">
        <h2>آزمون ها</h2>
    </div>
    <div class="panel-group" id="panel-group">
        {% if sub_categories.count == 0 %}
            <h3>
                با عرض پوزش در حال حاضر آزمونی در این بخش وجود ندارد
            </h3>
            <p>
                ممکن است که طبقه بندی آزمونی که شما به آن مراجعه کردید وجود نداشته باشد و یا در حال حاضر شامل آزمونی
                برای برگذاری نباشد
            </p>
            <img src="{% static "image/come-back-later.jpg" %}"/>
        {% endif %}
        {% for cat in sub_categories %}
            <div class="panel panel-success">

                <div class="panel-heading-exam">
                    <a data-toggle="collapse" data-parent="panel-group" href="#" data-target="#cat-{{ cat.name }}">
                        <div class="panel-title">
                            <div class="row">
                                <div class="col-xs-9 col-sm-10">
                                    {{ cat.local_name }}

                                </div>
                                <div class="col-xs-3 col-sm-2">
                                    <div class="badge">
                                        {{ cat.number_of_exams }}
                                        &nbsp;
                                        آزمون
                                    </div>
                                </div>
                            </div>
                        </div>
                    </a>


                </div>
                <div class="panel-body collapse" id="cat-{{ cat.name }}"
                     style="text-align: center; justify-content: center;">

                    {% for exam in cat.exam_set.all %}
                        <div class="exam-container col-lg-3 center-block"
                             style="text-align:center;background-color: #e0e0e0;border-radius: 8px; padding-top: 10px; padding-bottom: 10px; margin: 20px; min-height: 200px;">
                            <p style="font-weight: bold; font-size:17px;"> {{ exam.local_name }}</p>

                            <div style="min-height: 80px;">
                                <p style="font-size: 13px; font-weight: normal;"> {{ exam.description | safe }} </p>
                            </div>
                            <div class="badge" style="margin-bottom: 20px;">
                                {{ exam.duration }}
                                &nbsp;
                                دقیقه
                            </div>

                            <div>
                                <a class="btn btn-primary" href="{% url 'exam:intro' exam.id %}">شرکت در آزمون</a>
                            </div>
                        </div>
                    {% endfor %}
                </div>
            </div>
        {% endfor %}
    </div>
{% endblock %}